
public class KF163cc extends KFx3cc {

	protected int[] generateRX( long rx ){
		int[] b = new int[4];
		
		if( rx > 100 && rx < 200 ) rx *= 1000000;
		if( rx > 1000 && rx < 2000 ) rx *= 100000;
		if( rx > 10000 && rx < 20000 ) rx *= 10000;
		if( rx > 100000 && rx < 200000 ) rx *= 1000;
		if( rx > 1000000 && rx < 2000000 ) rx *= 100;
		if( rx > 10000000 && rx < 20000000 ) rx *= 10;
		
		rx -= 21400000;
		
		if( rx % 12500 == 0 ){
		
			if( rx >= 320000000 ){
				b[2] |= ( 1 << 3 );
				rx -= 320000000;
			}
			if( rx >= 160000000 ){
				b[2] |= ( 1 << 2 );
				rx -= 160000000;
			}
			if( rx >= 80000000 ){
				b[2] |= ( 1 << 1 );
				rx -= 80000000;
			}
			if( rx >= 40000000 ){
				b[2] |= ( 1 << 0 );
				rx -= 40000000;
			}
			if( rx >= 20000000 ){
				b[3] |= ( 1 << 3 );
				rx -= 20000000;
			}
			if( rx >= 10000000 ){
				b[3] |= ( 1 << 2 );
				rx -= 10000000;
			}
			if( rx >= 5000000 ){
				b[3] |= ( 1 << 1 );
				rx -= 5000000;
			}
			if( rx >= 2500000 ){
				b[3] |= ( 1 << 0 );
				rx -= 2500000;
			}
			if( rx >= 1250000 ){
				b[1] |= ( 1 << 3 );
				rx -= 1250000;
			}
			if( rx >= 800000 ){
				b[1] |= ( 1 << 2 );
				rx -= 800000;
			}
			if( rx >= 400000 ){
				b[1] |= ( 1 << 1 );
				rx -= 400000;
			}
			if( rx >= 200000 ){
				b[1] |= ( 1 << 0 );
				rx -= 200000;
			}
			if( rx >= 100000 ){
				b[0] |= ( 1 << 3 );
				rx -= 100000;
			}
			if( rx >= 50000 ){
				b[0] |= ( 1 << 2 );
				rx -= 50000;
			}
			if( rx >= 25000 ){
				b[0] |= ( 1 << 1 );
				rx -= 25000;
			}
			if( rx >= 12500 ){
				b[0] |= ( 1 << 0 );
				rx -= 12500;
			}
		} else {
			
			if( rx >= 256000000 ){
				b[2] |= ( 1 << 3 );
				rx -= 256000000;
			}
			if( rx >= 128000000 ){
				b[2] |= ( 1 << 2 );
				rx -= 128000000;
			}
			if( rx >= 64000000 ){
				b[2] |= ( 1 << 1 );
				rx -= 64000000;
			}
			if( rx >= 32000000 ){
				b[2] |= ( 1 << 0 );
				rx -= 32000000;
			}
			b[2] |= ( 1 << 4 );
			if( rx >= 16000000 ){
				b[3] |= ( 1 << 3 );
				rx -= 16000000;
			}
			if( rx >= 8000000 ){
				b[3] |= ( 1 << 2 );
				rx -= 8000000;
			}
			if( rx >= 4000000 ){
				b[3] |= ( 1 << 1 );
				rx -= 4000000;
			}
			if( rx >= 2000000 ){
				b[3] |= ( 1 << 0 );
				rx -= 2000000;
			}
			b[3] |= ( 1 << 4 );
			if( rx >= 1000000 ){
				b[1] |= ( 1 << 3 );
				rx -= 1000000;
			}
			if( rx >= 640000 ){
				b[1] |= ( 1 << 2 );
				rx -= 640000;
			}
			if( rx >= 320000 ){
				b[1] |= ( 1 << 1 );
				rx -= 320000;
			}
			if( rx >= 160000 ){
				b[1] |= ( 1 << 0 );
				rx -= 160000;
			}
			b[1] |= ( 1 << 4 );
			if( rx >= 80000 ){
				b[0] |= ( 1 << 3 );
				rx -= 80000;
			}
			if( rx >= 40000 ){
				b[0] |= ( 1 << 2 );
				rx -= 40000;
			}
			if( rx >= 20000 ){
				b[0] |= ( 1 << 1 );
				rx -= 20000;
			}
			if( rx >= 10000 ){
				b[0] |= ( 1 << 0 );
				rx -= 10000;
			}
			b[0] |= ( 1 << 4 );
		}
		return( b );
	}

	protected int[] generateTX( long tx ){
		int[] b = new int[4];
		
		if( tx > 100 && tx < 200 ) tx *= 1000000;
		if( tx > 1000 && tx < 2000 ) tx *= 100000;
		if( tx > 10000 && tx < 20000 ) tx *= 10000;
		if( tx > 100000 && tx < 200000 ) tx *= 1000;
		if( tx > 1000000 && tx < 2000000 ) tx *= 100;
		if( tx > 10000000 && tx < 20000000 ) tx *= 10;
		
		if( tx % 12500 == 0 ){

			if( tx >= 320000000 ){
				b[2] |= ( 1 << 3 );
				tx -= 320000000;
			}
			if( tx >= 160000000 ){
				b[2] |= ( 1 << 2 );
				tx -= 160000000;
			}
			if( tx >= 80000000 ){
				b[2] |= ( 1 << 1 );
				tx -= 80000000;
			}
			if( tx >= 40000000 ){
				b[2] |= ( 1 << 0 );
				tx -= 40000000;
			}
			if( tx >= 20000000 ){
				b[3] |= ( 1 << 3 );
				tx -= 20000000;
			}
			if( tx >= 10000000 ){
				b[3] |= ( 1 << 2 );
				tx -= 10000000;
			}
			if( tx >= 5000000 ){
				b[3] |= ( 1 << 1 );
				tx -= 5000000;
			}
			if( tx >= 2500000 ){
				b[3] |= ( 1 << 0 );
				tx -= 2500000;
			}
			if( tx >= 1250000 ){
				b[1] |= ( 1 << 3 );
				tx -= 1250000;
			}
			if( tx >= 800000 ){
				b[1] |= ( 1 << 2 );
				tx -= 800000;
			}
			if( tx >= 400000 ){
				b[1] |= ( 1 << 1 );
				tx -= 400000;
			}
			if( tx >= 200000 ){
				b[1] |= ( 1 << 0 );
				tx -= 200000;
			}
			if( tx >= 100000 ){
				b[0] |= ( 1 << 3 );
				tx -= 100000;
			}
			if( tx >= 50000 ){
				b[0] |= ( 1 << 2 );
				tx -= 50000;
			}
			if( tx >= 25000 ){
				b[0] |= ( 1 << 1 );
				tx -= 25000;
			}
			if( tx >= 12500 ){
				b[0] |= ( 1 << 0 );
				tx -= 12500;
			}
		} else {
	
			if( tx >= 256000000 ){
				b[2] |= ( 1 << 3 );
				tx -= 256000000;
			}
			if( tx >= 128000000 ){
				b[2] |= ( 1 << 2 );
				tx -= 128000000;
			}
			if( tx >= 64000000 ){
				b[2] |= ( 1 << 1 );
				tx -= 64000000;
			}
			if( tx >= 32000000 ){
				b[2] |= ( 1 << 0 );
				tx -= 32000000;
			}
			b[2] |= ( 1 << 4 );
			if( tx >= 16000000 ){
				b[3] |= ( 1 << 3 );
				tx -= 16000000;
			}
			if( tx >= 8000000 ){
				b[3] |= ( 1 << 2 );
				tx -= 8000000;
			}
			if( tx >= 4000000 ){
				b[3] |= ( 1 << 1 );
				tx -= 4000000;
			}
			if( tx >= 2000000 ){
				b[3] |= ( 1 << 0 );
				tx -= 2000000;
			}
			b[3] |= ( 1 << 4 );
			if( tx >= 1000000 ){
				b[1] |= ( 1 << 3 );
				tx -= 1000000;
			}
			if( tx >= 640000 ){
				b[1] |= ( 1 << 2 );
				tx -= 640000;
			}
			if( tx >= 320000 ){
				b[1] |= ( 1 << 1 );
				tx -= 320000;
			}
			if( tx >= 160000 ){
				b[1] |= ( 1 << 0 );
				tx -= 160000;
			}
			b[1] |= ( 1 << 4 );
			if( tx >= 80000 ){
				b[0] |= ( 1 << 3 );
				tx -= 80000;
			}
			if( tx >= 40000 ){
				b[0] |= ( 1 << 2 );
				tx -= 40000;
			}
			if( tx >= 20000 ){
				b[0] |= ( 1 << 1 );
				tx -= 20000;
			}
			if( tx >= 10000 ){
				b[0] |= ( 1 << 0 );
				tx -= 10000;
			}
			b[0] |= ( 1 << 4 );
		}
		return( b );
	}
}
