
public class KF83cc extends KFx3cc {

	protected int[] generateRX( long rx ){
		int[] b = new int[4];
		
		if( rx > 70 && rx < 100 ) rx *= 1000000;
		if( rx > 700 && rx < 1000 ) rx *= 100000;
		if( rx > 7000 && rx < 10000 ) rx *= 10000;
		if( rx > 70000 && rx < 100000 ) rx *= 1000;
		if( rx > 700000 && rx < 1000000 ) rx *= 100;
		if( rx > 7000000 && rx < 10000000 ) rx *= 10;
		
		rx += 21400000;
		
		if( rx % 5000 == 0 ){
			
			if( rx >= 64000000 ){
				b[2] |= ( 1 << 3 );
				rx -= 64000000;
			}
			if( rx >= 32000000 ){
				b[2] |= ( 1 << 2 );
				rx -= 32000000;
			}
			if( rx >= 16000000 ){
				b[2] |= ( 1 << 1 );
				rx -= 16000000;
			}
			if( rx >= 8000000 ){
				b[2] |= ( 1 << 0 );
				rx -= 8000000;
			}
			b[2] |= ( 1 << 4 );
			if( rx >= 4000000 ){
				b[3] |= ( 1 << 3 );
				rx -= 4000000;
			}
			if( rx >= 2000000 ){
				b[3] |= ( 1 << 2 );
				rx -= 2000000;
			}
			if( rx >= 1000000 ){
				b[3] |= ( 1 << 1 );
				rx -= 1000000;
			}
			if( rx >= 500000 ){
				b[3] |= ( 1 << 0 );
				rx -= 500000;
			}
			b[3] |= ( 1 << 4 );
			if( rx >= 250000 ){
				b[1] |= ( 1 << 3 );
				rx -= 250000;
			}
			if( rx >= 320000 ){
				b[1] |= ( 1 << 2 );
				rx -= 320000;
			}
			if( rx >= 160000 ){
				b[1] |= ( 1 << 1 );
				rx -= 160000;
			}
			if( rx >= 80000 ){
				b[1] |= ( 1 << 0 );
				rx -= 80000;
			}
			b[1] |= ( 1 << 4 );
			if( rx >= 40000 ){
				b[0] |= ( 1 << 3 );
				rx -= 40000;
			}
			if( rx >= 20000 ){
				b[0] |= ( 1 << 2 );
				rx -= 20000;
			}
			if( rx >= 10000 ){
				b[0] |= ( 1 << 1 );
				rx -= 10000;
			}
			if( rx >= 5000 ){
				b[0] |= ( 1 << 0 );
				rx -= 5000;
			}
			b[0] |= ( 1 << 4 );
		} else {
			if( rx >= 80000000 ){
				b[2] |= ( 1 << 3 );
				rx -= 80000000;
			}
			if( rx >= 40000000 ){
				b[2] |= ( 1 << 2 );
				rx -= 40000000;
			}
			if( rx >= 20000000 ){
				b[2] |= ( 1 << 1 );
				rx -= 20000000;
			}
			if( rx >= 10000000 ){
				b[2] |= ( 1 << 0 );
				rx -= 10000000;
			}
			if( rx >= 5000000 ){
				b[3] |= ( 1 << 3 );
				rx -= 5000000;
			}
			if( rx >= 2500000 ){
				b[3] |= ( 1 << 2 );
				rx -= 2500000;
			}
			if( rx >= 1250000 ){
				b[3] |= ( 1 << 1 );
				rx -= 1250000;
			}
			if( rx >= 625000 ){
				b[3] |= ( 1 << 0 );
				rx -= 625000;
			}
			if( rx >= 312500 ){
				b[1] |= ( 1 << 3 );
				rx -= 312500;
			}
			if( rx >= 400000 ){
				b[1] |= ( 1 << 2 );
				rx -= 400000;
			}
			if( rx >= 200000 ){
				b[1] |= ( 1 << 1 );
				rx -= 200000;
			}
			if( rx >= 100000 ){
				b[1] |= ( 1 << 0 );
				rx -= 100000;
			}
			if( rx >= 50000 ){
				b[0] |= ( 1 << 3 );
				rx -= 50000;
			}
			if( rx >= 25000 ){
				b[0] |= ( 1 << 2 );
				rx -= 25000;
			}
			if( rx >= 12500 ){
				b[0] |= ( 1 << 1 );
				rx -= 12500;
			}
			if( rx >= 6250 ){
				b[0] |= ( 1 << 0 );
				rx -= 6250;
			}
		}
		return( b );
	}

	protected int[] generateTX( long tx ){
		int[] b = new int[4];
		
		if( tx > 70 && tx < 100 ) tx *= 1000000;
		if( tx > 700 && tx < 1000 ) tx *= 100000;
		if( tx > 7000 && tx < 10000 ) tx *= 10000;
		if( tx > 70000 && tx < 100000 ) tx *= 1000;
		if( tx > 700000 && tx < 1000000 ) tx *= 100;
		if( tx > 7000000 && tx < 10000000 ) tx *= 10;
		
		if( tx % 5000 == 0 ){
			
			if( tx >= 64000000 ){
				b[2] |= ( 1 << 3 );
				tx -= 64000000;
			}
			if( tx >= 32000000 ){
				b[2] |= ( 1 << 2 );
				tx -= 32000000;
			}
			if( tx >= 16000000 ){
				b[2] |= ( 1 << 1 );
				tx -= 16000000;
			}
			if( tx >= 8000000 ){
				b[2] |= ( 1 << 0 );
				tx -= 8000000;
			}
			b[2] |= ( 1 << 4 );
			if( tx >= 4000000 ){
				b[3] |= ( 1 << 3 );
				tx -= 4000000;
			}
			if( tx >= 2000000 ){
				b[3] |= ( 1 << 2 );
				tx -= 2000000;
			}
			if( tx >= 1000000 ){
				b[3] |= ( 1 << 1 );
				tx -= 1000000;
			}
			if( tx >= 500000 ){
				b[3] |= ( 1 << 0 );
				tx -= 500000;
			}
			b[3] |= ( 1 << 4 );
			if( tx >= 250000 ){
				b[1] |= ( 1 << 3 );
				tx -= 250000;
			}
			if( tx >= 320000 ){
				b[1] |= ( 1 << 2 );
				tx -= 320000;
			}
			if( tx >= 160000 ){
				b[1] |= ( 1 << 1 );
				tx -= 160000;
			}
			if( tx >= 80000 ){
				b[1] |= ( 1 << 0 );
				tx -= 80000;
			}
			b[1] |= ( 1 << 4 );
			if( tx >= 40000 ){
				b[0] |= ( 1 << 3 );
				tx -= 40000;
			}
			if( tx >= 20000 ){
				b[0] |= ( 1 << 2 );
				tx -= 20000;
			}
			if( tx >= 10000 ){
				b[0] |= ( 1 << 1 );
				tx -= 10000;
			}
			if( tx >= 5000 ){
				b[0] |= ( 1 << 0 );
				tx -= 5000;
			}
			b[0] |= ( 1 << 4 );

		} else {
			
			if( tx >= 80000000 ){
				b[2] |= ( 1 << 3 );
				tx -= 80000000;
			}
			if( tx >= 40000000 ){
				b[2] |= ( 1 << 2 );
				tx -= 40000000;
			}
			if( tx >= 20000000 ){
				b[2] |= ( 1 << 1 );
				tx -= 20000000;
			}
			if( tx >= 10000000 ){
				b[2] |= ( 1 << 0 );
				tx -= 10000000;
			}
			if( tx >= 5000000 ){
				b[3] |= ( 1 << 3 );
				tx -= 5000000;
			}
			if( tx >= 2500000 ){
				b[3] |= ( 1 << 2 );
				tx -= 2500000;
			}
			if( tx >= 1250000 ){
				b[3] |= ( 1 << 1 );
				tx -= 1250000;
			}
			if( tx >= 625000 ){
				b[3] |= ( 1 << 0 );
				tx -= 625000;
			}
			if( tx >= 312500 ){
				b[1] |= ( 1 << 3 );
				tx -= 312500;
			}
			if( tx >= 400000 ){
				b[1] |= ( 1 << 2 );
				tx -= 400000;
			}
			if( tx >= 200000 ){
				b[1] |= ( 1 << 1 );
				tx -= 200000;
			}
			if( tx >= 100000 ){
				b[1] |= ( 1 << 0 );
				tx -= 100000;
			}
			if( tx >= 50000 ){
				b[0] |= ( 1 << 3 );
				tx -= 50000;
			}
			if( tx >= 25000 ){
				b[0] |= ( 1 << 2 );
				tx -= 25000;
			}
			if( tx >= 12500 ){
				b[0] |= ( 1 << 1 );
				tx -= 12500;
			}
			if( tx >= 6250 ){
				b[0] |= ( 1 << 0 );
				tx -= 6250;
			}
		}
		return( b );
	}
}
